#ifndef ContourTracking_H
#define ContourTracking_H

#include "ContourTracker.h"
#include "Curve2D.h"
#include "Point.h"

/*!
 * \file ContourTracking.h
 * \brief  suivi de contour 
 * \author Tristan Roussillon
 *
 */

/*!
 * \class ContourTracking
 * \brief  suivi de contour
 * \author Tristan Roussillon
 *
 */
class ContourTracking {

private : 
	Point<int> startingPoint;/*!< point de depart */
	Curve2D* curve; /*!< pointeur vers une courbe */
	ContourTracker* firstPoint; /*!< premier point du contour */
	ContourTracker* lastPoint; /*!< dernier point du contour */

public : 
/*!
 * \brief  constructeur du suiveur de contour
 *
 * \param c : une courbe a discretiser
 *
 */
	ContourTracking(Curve2D* c);
/*!
 * \brief  destructeur
 *
 */
	~ContourTracking();
/*!
 * \brief  accesseur au point de depart
 *
 */
	Point<double> getStartingPoint() const;
/*!
 * \brief  pointeur vers le premier point du contour
 *
 */
	ContourTracker begin() const;
/*!
 * \brief  pointeur vers le dernier point du contour
 *
 */
	ContourTracker end() const;

};

      
#endif
