#ifndef Curve2D_H
#define Curve2D_H

#include "Point.h"
#include <cmath>

/*!
 * \file Curve2D.h
 * \brief dfinition d'une courbe
 * \author Tristan Roussillon
 *
 */


/*!
 * \class Curve2D
 * \brief Courbe
 * \author Tristan Roussillon
 * cette classe, abstraite, reprsente l'ensemble des fonctions implicites du plan formant des courbes telles que les ellipses, les polygones rguliers, les paraboles, etc.
 */

class Curve2D {

protected :

Point<int> firstPoint; /*!< premier point du contour*/
Point<int> lastPoint; /*!< dernier point du contour*/
 
public : 

/*!
 * \brief predicat: est  l'interieur de
 *
 * Mthode virtuelle pure, permettant de decider si un point se trouve  l'interieur de la courbe ou non.
 *
 * \param p : point
 *
 */
 	virtual bool isInside(const Point<int>& p) const = 0;

/*!
 * \brief premier point du contour a suivre
 *
 */
 	Point<int> getFirstPoint() const;

/*!
 * \brief dernier point du contour a suivre
 *
 */
 	Point<int> getLastPoint() const;

	virtual ~Curve2D() {}

};

      
#endif

