#ifndef Ellipse_H
#define Ellipse_H

#include "Curve2D.h"
/*!
 * \file Ellipse.h
 * \brief  Definition d'une parabole
 * \author Tristan Roussillon
 *
 */

/*!
 * \class Ellipse
 * \brief Cette classe represente une ellipse caracterise par 5 parametres 
 * \author Tristan Roussillon
 * 
 */

class Ellipse : public Curve2D {

public : 
	double cx; /*!< abscisse du centre */
	double cy; /*!< ordonnee du centre */
	double a; /*!< demi-petit axe de l'ellipse */
	double b; /*!< demi-grand axe de l'ellipse */
	double alpha; /*!<orientation */

/*!
 * \brief  Constructeur d'une parabole
 */
	Ellipse(double pcx, double pcy, double pa, double pb, double palpha);

/*!
 * \brief  predicat
 */
	bool isInside(const Point<int>& p) const;

};

      
#endif
