#ifndef Parabola_H
#define Parabola_H

#include "Curve2D.h"
#include <cstdlib>

/*!
 * \file Parabola.h
 * \brief  Definition d'une parabole
 * \author Tristan Roussillon
 *
 */

/*!
 * \class Parabola
 * \brief Cette classe represente une parabole caracterise par 3 parametre sur un intervalle 
 * \author Tristan Roussillon
 * 
 */

class Parabola : public Curve2D {

public : 
	//ax**2 + bx + c
	double a; /*!< parametre a de la parabole */
	double b; /*!< parametre b de la parabole */
	double c; /*!< parametre c de la parabole */
	int l; /*!< intervalle */

/*!
 * \brief  Constructeur d'une parabole
 */
	Parabola(double a, double b, double c, int l);

/*!
 * \brief  predicat
 */
	bool isInside(const Point<int>& p) const;

};

      
#endif
