#ifndef RegularPolygon_H
#define RegularPolygon_H

#include "Curve2D.h"
/*!
 * \file RegularPolygon.h
 * \brief  Definition d'un polygone regulier
 * \author Tristan Roussillon
 *
 */

/*!
 * \class RegularPolygon
 * \brief Cette classe represente un polygone regulier caracterise 
 *  par son nombre de cotes et par la longueur de ses cotes 
 * \author Tristan Roussillon
 * 
 */

class RegularPolygon : public Curve2D {

public : 
	
	int n; /*!< nombre de cotes du polygone*/
	double c; /*!<  longueur d'un cote du polygone*/

/*!
 * \brief  
 * constructeur du polygone régulier 
 * \param pc : longueur des cotes
 * \param pn : nombre de cotes
 */
	RegularPolygon(int pn, double pc);

/*!
 * \brief  predicat
 */
	bool isInside(const Point<int>& p) const;

};

      
#endif
