#ifndef Rose_H
#define Rose_H

#include "Curve2D.h"
/*!
 * \file Rose.h
 * \brief  Definition d'une rosace
 * \author Tristan Roussillon
 *
 */

/*!
 * \class Rose
 * \brief Cette classe represente une rosace caracterise par 5 parametres 
 * \author Tristan Roussillon
 * 
 */

class Rose : public Curve2D {

public : 

	double rin; /*!< cercle interne */
	double rout; /*!< cercle externe */
	int n; /*!< nombre de petales */

/*!
 * \brief  Constructeur 
 */
	Rose(double prin, double prout, int pn);

/*!
 * \brief  predicat
 */
	bool isInside(const Point<int>& p) const;

};

      
#endif
