#ifndef Sin_H
#define Sin_H

#include "Curve2D.h"
#include <cstdlib>
/*!
 * \file Sin.h
 * \brief  Definition d'une sinusoide
 * \author Tristan Roussillon
 *
 */

/*!
 * \class Sin
 * \brief Cette classe represente une sinusoide caracterise par 3 parametres sur un intervalle 
 * \author Tristan Roussillon
 * 
 */

class Sin : public Curve2D {

public : 
	//a*cos(p*t+phi)
	double a; /*!< coefficient mutliplicateur du cosinus */
	double p; /*!< frequence */
	double phi; /*!< phase */
	int l; /*!< intervalle */

/*!
 * \brief  Constructeur d'une parabole
 */
	Sin(double a, double p, double phi, int l);

/*!
 * \brief  predicat
 */
	bool isInside(const Point<int>& p) const;

};

      
#endif
