#include "../inc/ContourTracking.h"
#include "../inc/Ellipse.h"
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstring>


unsigned randomInt(unsigned N) {
  return (unsigned)((double)std::rand()/((double)RAND_MAX+1)*N);
}
double randomDouble(unsigned N) {
  return ((double)std::rand()/((double)RAND_MAX+1)*N);
}

int main(int argc, char *argv[]) {

	if (argc < 6) {
		std::cerr << "print a b cx cy theta such that" << std::endl;
		std::cerr << "a and b are the great and small axis" << std::endl;
		std::cerr << "c is the center" << std::endl;
		std::cerr << "theta is the angle between the main axis and the x-axis" << std::endl;
		std::cerr << "use 'r' for a random value" << std::endl;
	} else {

		//initialisation du generateur de nombres aleatoires
		std::srand(std::time(NULL)); 

		//variables
		double a, b, theta, cx, cy;

		if (strcmp(argv[1],"r")==0) {
			a = randomInt(20) + 20;
		} else {
			std::string value = argv[1];
			std::istringstream is(value);
			is >> a;
		}
		if (strcmp(argv[2],"r")==0) {
			b = randomInt(60) + 20;
		} else {
			std::string value = argv[2];
			std::istringstream is(value);
			is >> b;
		}
		if (strcmp(argv[3],"r")==0) {
			cx = (randomDouble(1000)/1000);
		} else {
			std::string value = argv[3];
			std::istringstream is(value);
			is >> cx;
		}
		if (strcmp(argv[4],"r")==0) {
			cy = (randomDouble(1000)/1000);
		} else {
			std::string value = argv[4];
			std::istringstream is(value);
			is >> cy;
		}
		if (strcmp(argv[5],"r")==0) {
			theta = (randomDouble(1000)/1000) * M_PI;
		} else {
			std::string value = argv[5];
			std::istringstream is(value);
			is >> theta;
		}

	std::cerr << "a=" << a << ", b=" << b << ", (" << cx << "," << cy << "), theta=" << theta << std::endl;


	//generation
	Curve2D *curve = new Ellipse(cx, cy, a, b, theta); 
	ContourTracking *suivi = new ContourTracking(curve);
	Point<double> stPoint = suivi->getStartingPoint();
	std::string code = "";
	for (ContourTracker i = suivi->begin(); i != suivi->end(); ++i) {
		code += i.getLetter();
	}
	delete (suivi);
	delete (curve);

	//affichage
	std::cout << code << ";";
	std::cout << stPoint.x << ";" << stPoint.y << ";" << std::endl;

	}
	return 0;
}
