#include "../inc/ContourTracking.h"
#include "../inc/Parabola.h"
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstring>

unsigned randomInt(unsigned N) {
  return (unsigned)((double)std::rand()/((double)RAND_MAX+1)*N);
}
double randomDouble(unsigned N) {
  return ((double)std::rand()/((double)RAND_MAX+1)*N);
}

int main(int argc, char *argv[]) {

	if (argc < 5) {
		std::cerr << "print a b c l such that" << std::endl;
		std::cerr << "ax2 + bx + c and 0 <= x < l" << std::endl;
		std::cerr << "use 'r' for a random value" << std::endl;
	} else {

		//initialisation du generateur de nombres aleatoires
		std::srand(std::time(NULL)); 

		//variables
		double a, b, c;
		int l;

		if (strcmp(argv[1],"r")==0) {
			a = (randomDouble(100)/500);
		} else {
			std::string value = argv[1];
			std::istringstream is(value);
			is >> a;
		}
		if (strcmp(argv[2],"r")==0) {
			b = (randomDouble(100)/200);
		} else {
			std::string value = argv[2];
			std::istringstream is(value);
			is >> b;
		}
		if (strcmp(argv[3],"r")==0) {
			c = randomInt(10) + ((randomDouble(100)/100));
		} else {
			std::string value = argv[3];
			std::istringstream is(value);
			is >> c;
		}
		if (strcmp(argv[4],"r")==0) {
			l = randomInt(50) + 30;
		} else {
			std::string value = argv[4];
			std::istringstream is(value);
			is >> l;
		}

		std::cerr << a << "x2 + " << b << "x " << c << ", 0 <= x < " << l << std::endl;

		//generation
		Curve2D *curve = new Parabola(a,b,c,l); 
		ContourTracking *suivi = new ContourTracking(curve);
		Point<double> stPoint = suivi->getStartingPoint();
		std::string code = "";
		for (ContourTracker i = suivi->begin(); i != suivi->end(); ++i) {
			code += i.getLetter();
		}
		delete (suivi);
		delete (curve);

		//affichage
		std::cout << code << ";";
		std::cout << stPoint.x << ";" << stPoint.y << ";" << std::endl;

	}
	return 0;
}
