#include "../inc/ContourTracking.h"
#include "../inc/RegularPolygon.h"
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstring>

unsigned randomInt(unsigned N) {
  return (unsigned)((double)std::rand()/((double)RAND_MAX+1)*N);
}
double randomDouble(unsigned N) {
  return ((double)std::rand()/((double)RAND_MAX+1)*N);
}

int main(int argc, char *argv[]) {

	if (argc < 3) {
		std::cerr << "print n c such that" << std::endl;
		std::cerr << "n is the number of sides" << std::endl;
		std::cerr << "c is the length of the n sides" << std::endl;
		std::cerr << "use 'r' for a random value" << std::endl;
	} else {

		//initialisation du generateur de nombres aleatoires
		std::srand(std::time(NULL)); 

		//variables
		double c;
		int n;

		if (strcmp(argv[1],"r")==0) {
			n = randomInt(10) + 3;
		} else {
			std::string value = argv[1];
			std::istringstream is(value);
			is >> n;
		}
		if (strcmp(argv[2],"r")==0) {
			c = (randomDouble(500)/10) + 20;
		} else {
			std::string value = argv[2];
			std::istringstream is(value);
			is >> c;
		}

		std::cerr << n << " sides of length " << c << "." << std::endl;

	//generation
	Curve2D *curve = new RegularPolygon(n,c); 
	ContourTracking *suivi = new ContourTracking(curve);
	Point<double> stPoint = suivi->getStartingPoint();
	std::string code = "";
	for (ContourTracker i = suivi->begin(); i != suivi->end(); ++i) {
		code += i.getLetter();
	}
	delete (suivi);
	delete (curve);

	//affichage
	std::cout << code << ";";
	std::cout << stPoint.x << ";" << stPoint.y << ";" << std::endl;

	}
	return 0;
}
