#include "../inc/ContourTracking.h"
#include "../inc/Rose.h"
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstring>

unsigned randomInt(unsigned N) {
  return (unsigned)((double)std::rand()/((double)RAND_MAX+1)*N);
}
double randomDouble(unsigned N) {
  return ((double)std::rand()/((double)RAND_MAX+1)*N);
}

int main(int argc, char *argv[]) {

	if (argc < 3) {
		std::cerr << "print ri ro n such that" << std::endl;
		std::cerr << "ri = inner radius" << std::endl;
		std::cerr << "ro = outer radius" << std::endl;
		std::cerr << "n = number of petals" << std::endl;
		std::cerr << "use 'r' for a random value" << std::endl;
	} else {

		//initialisation du generateur de nombres aleatoires
		std::srand(std::time(NULL)); 

		//variables
		double rin, rout;
		int n;

		if (strcmp(argv[1],"r")==0) {
			rin = 50 + randomInt(10);
		} else {
			std::string value = argv[1];
			std::istringstream is(value);
			is >> rin;
		}
		if (strcmp(argv[2],"r")==0) {
			rout = rin + 15 + randomInt(15);
		} else {
			std::string value = argv[2];
			std::istringstream is(value);
			is >> rout;
		}
		if (strcmp(argv[3],"r")==0) {
			n = 2 + randomInt(8);
		} else {
			std::string value = argv[3];
			std::istringstream is(value);
			is >> n;
		}

		std::cerr << "ri=" << rin << ", ro=" << rout << ", n=" << n << std::endl;

		//generation
		Curve2D *curve = new Rose(rin, rout, n); 
		ContourTracking *suivi = new ContourTracking(curve);
		Point<double> stPoint = suivi->getStartingPoint();
		std::string code = "";
		for (ContourTracker i = suivi->begin(); i != suivi->end(); ++i) {
			code += i.getLetter();
		}
		delete (suivi);
		delete (curve);

		//affichage
		std::cout << code << ";";
		std::cout << stPoint.x << ";" << stPoint.y << ";" << std::endl;

	}

	return 0;
}
