#include "../inc/ContourTracking.h"
#include "../inc/Sin.h"
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstring>

unsigned randomInt(unsigned N) {
  return (unsigned)((double)std::rand()/((double)RAND_MAX+1)*N);
}
double randomDouble(unsigned N) {
  return ((double)std::rand()/((double)RAND_MAX+1)*N);
}

int main(int argc, char *argv[]) {

	if (argc < 5) {
		std::cerr << "print a f p l such that" << std::endl;
		std::cerr << "a*cos(f*t+p) and 0 <= t < l" << std::endl;
		std::cerr << "use 'r' for a random value" << std::endl;
	} else {

		//initialisation du generateur de nombres aleatoires
		std::srand(std::time(NULL)); 

		//variables
		double a, f, p;
		int l;

		if (strcmp(argv[1],"r")==0) {
			a = 5 + (randomDouble(1000)/100);
		} else {
			std::string value = argv[1];
			std::istringstream is(value);
			is >> a;
		}
		if (strcmp(argv[2],"r")==0) {
			f = 1/((double)(3 + randomInt(5)));
		} else {
			std::string value = argv[2];
			std::istringstream is(value);
			is >> f;
		}
		if (strcmp(argv[3],"r")==0) {
			p = randomInt(10) + ((randomDouble(100)/100));
		} else {
			std::string value = argv[3];
			std::istringstream is(value);
			is >> p;
		}
		if (strcmp(argv[4],"r")==0) {
			l = randomInt(50) + 50;
		} else {
			std::string value = argv[4];
			std::istringstream is(value);
			is >> l;
		}

		std::cerr << a << "*cos(" << f << "*t + " << p << "), 0 <= t < " << l << std::endl;

		//generation
		Curve2D *curve = new Sin(a,f,p,l); 
		ContourTracking *suivi = new ContourTracking(curve);
		Point<double> stPoint = suivi->getStartingPoint();
		std::string code = "";
		for (ContourTracker i = suivi->begin(); i != suivi->end(); ++i) {
			code += i.getLetter();
std::cout << i.getLetter();
		}
		delete (suivi);
		delete (curve);

		//affichage
		std::cout << code << ";";
		std::cout << stPoint.x << ";" << stPoint.y << ";" << std::endl;

	}
	return 0;
}
