#include "../inc/ContourTracker.h"

ContourTracker::ContourTracker(Point<int> p, Curve2D* pc) {

	this->P = p;
	this->Q = Point<int>(p.x, p.y+1);
	this->R = Point<int>(p.x+1, p.y+1);
	this->S = Point<int>(p.x+1, p.y);
	this->v = Vecteur<int>(1,0);
	this->curve = pc;
	this->c = 0;

	//std::cerr << P << Q << R << S << "init" << std::endl;

}




std::string ContourTracker::getLetter() const {
	if (this->v == Vecteur<int>(1,0)) return "0";
	if (this->v == Vecteur<int>(0,1)) return "1";
	if (this->v == Vecteur<int>(-1,0)) return "2";
	if (this->v == Vecteur<int>(0,-1)) return "3";
}


void ContourTracker::operator++() {
	
	this->c++;

	if (this->curve->isInside(this->R)) { // a gauche
		this->v = (this->Q-this->P);
		this->P = this->R;
	} else if (this->curve->isInside(this->S)) { //tout droit
		this->v = (this->S-this->P);
		this->P = this->S;
		this->Q = this->R;
	} else { // a droite
		this->v = (this->P-this->Q);
		this->Q = this->S;
	}	

	this->R = Point<int>(this->Q.x+this->Q.y-this->P.y,this->Q.y+this->P.x-this->Q.x);
	this->S = Point<int>(this->P.x+this->Q.y-this->P.y,this->P.y+this->P.x-this->Q.x);

	//std::cerr << P << Q << R << S << "apres" << std::endl;
	//std::cin.get();
}

void ContourTracker::operator--() {

	this->c--;

	this->R = this->Q + (this->Q - this->R);
	this->S = this->P + (this->P - this->S);

	this->operator++();

}

bool ContourTracker::operator==(const ContourTracker& t) const {
	return ((t.P == this->P) && (t.Q == this->Q) && (t.R == this->R) && (t.S == this->S) && (t.curve == this->curve) && (this->c != 0));
}

bool ContourTracker::operator!=(const ContourTracker& t) const {
 return ((t.P != this->P) || (t.Q != this->Q) || (t.R != this->R) || (t.S != this->S) || (t.curve != this->curve) || (this->c == 0));
} 


