#include "../inc/ContourTracking.h"

ContourTracking::ContourTracking(Curve2D* c) {
	this->curve = c;
	this->startingPoint = this->curve->getFirstPoint();
	this->firstPoint = new ContourTracker(this->startingPoint,this->curve); 
	this->lastPoint = new ContourTracker(this->curve->getLastPoint(),this->curve); 
}

ContourTracking::~ContourTracking() {
	delete(this->firstPoint); 
	delete(this->lastPoint);
}

Point<double> ContourTracking::getStartingPoint() const {
	return Point<double>(this->startingPoint.x-0.5,this->startingPoint.y+0.5);
}

ContourTracker ContourTracking::begin() const {
	return *this->firstPoint;
}

ContourTracker ContourTracking::end() const {
	return *this->lastPoint;
}
