#include "../inc/RegularPolygon.h"

RegularPolygon::RegularPolygon(int pn, double pc) {

	//param
	this->n = pn;
	this->c = pc;

	int xmin = 0; 
	//calcul de l'ordonnee du point
 // du contour d'abscisse 0
	double theta = 2*M_PI/this->n;
	double Rin = (this->c/(2*std::sin(theta/2)))*std::cos(theta/2);
	int ymin = (int)std::floor(Rin);
 
	//premier point
	this->firstPoint = Point<int>(xmin,ymin);
	//dernier point
	this->lastPoint = this->firstPoint;
}


bool RegularPolygon::isInside(const Point<int>& p) const {

	//distance au centre
	int d = (p.x*p.x) + (p.y*p.y);
	//distance au centre calcule
	double theta = 2*M_PI/this->n;
	double Rin = (this->c/(2*std::sin(theta/2)))*std::cos(theta/2);
	double alpha = std::abs(std::atan2(p.x,p.y));
	double r = std::fmod(alpha, theta);
	if (r > (theta/2)) r = theta - r;
	double rho = Rin/std::cos(r);
	double dcalc = rho*rho;

	double epsilon = 0.0001; //
	return (d <= dcalc+epsilon);
}

