#include "../inc/Rose.h"
Rose::Rose(double prin, double prout, int pn) {

	//param
	this->rin = std::abs(prin);
	this->rout = std::abs(prout);
	this->n = pn;

	//premier point
	this->firstPoint = Point<int>(0,(int)std::floor(this->rout));
	//dernier point
	this->lastPoint = this->firstPoint;
}


bool Rose::isInside(const Point<int>& p) const {

	//var locales
	double d, dcalc, rho, t;
	//distance au centre
	d = (p.x)*(p.x) + (p.y)*(p.y);
	//distance au centre calcule
	t = std::abs(std::atan2((p.x),(p.y)));
	double q = this->n*t;
/*	int r = this->n%4;  
	if (r==1) q += 3*M_PI/2;
	if (r==2) q += M_PI;
	if (r==3) q += M_PI/2;*/
	rho = (this->rout+this->rin)/2 + ((this->rout-this->rin)/2)*std::cos(q);
	dcalc = rho*rho;

	return (d <= dcalc);
}

