#include "../inc/Sin.h"

Sin::Sin(double a, double p, double phi, int l) {
	this->a = a;
	this->p = p;
	this->phi = phi;
	this->l = std::abs(l);
	double yc1 = this->a*std::cos(this->phi);
	this->firstPoint = Point<int>(0,(int)std::floor(yc1));
	double yc2 = this->a*std::cos(this->p*this->l+this->phi);
	this->lastPoint = Point<int>(this->l,(int)std::floor(yc2));
}


bool Sin::isInside(const Point<int>& p) const {
	double yc = this->a*std::cos(this->p*p.x+this->phi);
	double y = p.y;
	return (y <= yc);
}

