#ifndef AdapterDSS0_H
#define AdapterDSS0_H

#include "AdapterDSS.h"
/*!
 * \file AdapterDSS0.h
 * \brief Definition d'un adaptateur aux DSS
 * \author Tristan Roussillon
 *
 */


/*!
 * \class AdapterDSS0
 * \brief adaptateur aux DSS
 * Cette classe modelise un adaptateur aux DSS
 * selon le modele de conception de l'adaptateur (adapter).
 * Appeler les methodes getXf() et getXl() permet
 * d'acceder aux points d'appui inferieurs.
 * \author Tristan Roussillon
 */
class AdapterDSS0 : public AdapterDSS {
public : 
	AdapterDSS0(DSS*);

/*!
 * \brief Methode 
 * permettant d'acceder a l'intercept
 * de la droite d'appui situe a gauche - c2 - 
 * du segment
 * 
 */
	int getC() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au premier point d'appui inferieur 
 * 
 */
	Point<int> getXf() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au dernier point d'appui inferieur 
 * 
 */
	Point<int> getXl() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au premier point d'appui superieur 
 * 
 */
	Point<int> getYf() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au dernier point d'appui superieur 
 * 
 */
	Point<int> getYl() const;
};

#endif

