#ifndef AdapterDSS1_H
#define AdapterDSS1_H

#include "AdapterDSS.h"
/*!
 * \file AdapterDSS1.h
 * \brief Definition d'un adaptateur aux DSS
 * \author Tristan Roussillon
 *
 */


/*!
 * \class AdapterDSS1
 * \brief adaptateur aux DSS
 * Cette classe modelise un adaptateur aux DSS
 * selon le modele de conception de l'adaptateur (adapter).
 * Appeler les methodes getXf() et getXl() permet
 * d'acceder aux points d'appui superieurs.
 * \author Tristan Roussillon
 */
class AdapterDSS1 : public AdapterDSS {
public : 
	AdapterDSS1(DSS*);
/*!
 * \brief Methode 
 * permettant d'acceder a l'intercept
 * de la droite d'appui situe a droite - c1 - 
 * du segment
 * 
 */
	int getC() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au premier point d'appui superieur 
 * 
 */
	Point<int> getXf() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au dernier point d'appui superieur 
 * 
 */
	Point<int> getXl() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au premier point d'appui inferieur 
 * 
 */
	Point<int> getYf() const;
/*!
 * \brief Methode 
 * permettant d'acceder 
 * au dernier point d'appui inferieur 
 * 
 */
	Point<int> getYl() const;
};

#endif


