#ifndef AdapterIteratorBack_H
#define AdapterIteratorBack_H
/*!
 * \file AdapterIteratorBack.h
 * \brief Definition d'une classe modelisant 
 * un adaptateur a un iterateur sur un conteneur
 * (selon le design pattern adapter).
 *
 * \author Tristan Roussillon
 *
 */


/*!
 * \class AdapterIteratorBack
 * \brief Classe generique et modelisant 
 * un adaptateur a un iterateur sur un conteneur
 * (selon le design pattern adapter).
 *
 * \author Tristan Roussillon
 * 
*/
template <class T, class Ti> class AdapterIteratorBack : public AdapterIterator<T,Ti> {
public : 
	AdapterIteratorBack(Ti*);
/*!
 * \brief Methode virtuelle permettant
 * d'acceder a l'element suivant du conteneur
 */
	void operator++(int);
/*!
 * \brief Methode permettant
 * d'acceder a l'element suivant du conteneur
 */
	void operator--(int);
};

template <class T, class Ti> AdapterIteratorBack<T,Ti>::AdapterIteratorBack(Ti *it) {
	this->i = it;
}

template <class T, class Ti> void AdapterIteratorBack<T,Ti>::operator++(int) {
	(*this->i)--;
}
template <class T, class Ti> void AdapterIteratorBack<T,Ti>::operator--(int) {
	(*this->i)++;
}
#endif
