#ifndef AdapterIteratorFront_H
#define AdapterIteratorFront_H

/*!
 * \file AdapterIteratorFront.h
 * \brief Definition d'une classe modelisant 
 * un adaptateur a un iterateur sur un conteneur
 * (selon le design pattern adapter).
 *
 * \author Tristan Roussillon
 *
 */


/*!
 * \class AdapterIteratorFront
 * \brief Classe generique et modelisant 
 * un adaptateur a un iterateur sur un conteneur
 * (selon le design pattern adapter).
 *
 * \author Tristan Roussillon
 * 
*/

template <class T, class Ti> class AdapterIteratorFront : public AdapterIterator<T,Ti> {
public : 
	AdapterIteratorFront(Ti*);
/*!
 * \brief Methode permettant
 * d'acceder a l'element suivant du conteneur
 */
	void operator++(int);
/*!
 * \brief Methode virtuelle permettant
 * d'acceder a l'element suivant du conteneur
 */
	void operator--(int);
};

template <class T, class Ti> AdapterIteratorFront<T,Ti>::AdapterIteratorFront(Ti *it) {
	this->i = it;
}

template <class T, class Ti> void AdapterIteratorFront<T,Ti>::operator++(int) {
	(*this->i)++;
}
template <class T, class Ti> void AdapterIteratorFront<T,Ti>::operator--(int) {
	(*this->i)--;
}
#endif
