#ifndef BackFrontSegIterator4ClosedContour_H
#define BackFrontSegIterator4ClosedContour_H

#include "BackFrontSegIterator.h"
#include "ContourIterator.h"

/*!
 * \file BackFrontSegIterator4ClosedContour.h
 * \brief  definition d'un iterateur de segments maximaux 
 * par ajout a l'avant et a l'arriere sur un contour complet
 * \author Tristan Roussillon
 *
 */

/*!
 * \class BackFrontSegIterator4ClosedContour
 * \brief iterateur de segments maximaux 
 * par ajout a l'avant et a l'arriere sur un contour complet
 * \author Tristan Roussillon
 *
 */
class BackFrontSegIterator4ClosedContour: public BackFrontSegIterator {

private : 

int n; /*!< nombre d'iterations */

public : 

/*!
 * \brief Constructeur
 * \param pf : fabrique du segment
 * \param pv : ensemble de segments
 * \param pi : iterateur de contour sur le premier point du segment
 * \param pj : iterateur de contour sur le dernier point du segment
 */
 BackFrontSegIterator4ClosedContour(
				FactoryFrontBackSeg* pf, 
				std::vector<FrontBackSeg*>* pv, 
				const ContourIterator& pi, 
				const ContourIterator& pj);


/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(AbstractSegIterator& t);
/*!
 * \brief operateur de difference
 */ 
	bool operator!=(AbstractSegIterator& t); 

};

      
#endif
