#ifndef BruteForceCover_H
#define BruteForceCover_H

#include "AbstractSegIterator.h"
#include "SegIterator.h"
#include "Contour.h"
#include "ContourIterator.h"
#include "ContourScan.h"
#include "FactorySeg.h"

/*!
 * \file BruteForceCover.h
 * \brief Couverture de segments
 * \author Tristan Roussillon
 *
 */

/*!
 * \class BruteForceCover
 * \brief Couverture de segments
 * \author Tristan Roussillon
 *
 */
class BruteForceCover {

private : 
	std::vector<Seg*> vSegs; /*!< ensemble des segments extraits au cours des iterations*/
	std::vector<Seg*> vTmp; /*!< ensemble des segments temporaires */
	AbstractSegIterator* firstSeg; /*!< premier segment du contour */
	AbstractSegIterator* lastSeg; /*!< dernier segment du contour */

public : 
/*!
 * \brief  constructeur 
 *
 * \param pc : un pointeur vers un contour
 *
 */
	BruteForceCover(Contour* pc, FactorySeg* pf);
/*!
 * \brief  destructeur
 *
 */
	~BruteForceCover();

/*!
 * \brief  pointeur vers le premier point du contour
 *
 */
	SegIterator begin() const;
/*!
 * \brief  pointeur vers le dernier point du contour
 *
 */
	SegIterator end() const;

};

      
#endif
