#ifndef BruteForceSegIterator4ClosedContour_H
#define BruteForceSegIterator4ClosedContour_H

#include "BruteForceSegIterator.h"
#include "ContourIterator.h"

/*!
 * \file BruteForceSegIterator4ClosedContour.h
 * \brief  definition d'un iterateur naif de segments maximaux 
 * \author Tristan Roussillon
 *
 */

/*!
 * \class BruteForceSegIterator4ClosedContour
 * \brief iterateur naif de segments maximaux sur un contour complet
 * \author Tristan Roussillon
 *
 */
class BruteForceSegIterator4ClosedContour: public BruteForceSegIterator {

private : 

int n; /*!< nombre d'iterations */

public : 

/*!
 * \brief Constructeur
 * \param pf : fabrique du segment
 * \param pv : ensemble de segments
 * \param pi : iterateur de contour sur le premier point du segment
 * \param pj : iterateur de contour sur le dernier point du segment
 */
 BruteForceSegIterator4ClosedContour(
				FactorySeg* pf, 
				std::vector<Seg*>* pv, 
				const ContourIterator& pi, 
				const ContourIterator& pj);


/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(AbstractSegIterator& t);
/*!
 * \brief operateur de difference
 */ 
	bool operator!=(AbstractSegIterator& t); 

};

      
#endif
