#ifndef BruteForceSegIterator4OpenContour_H
#define BruteForceSegIterator4OpenContour_H

#include "BruteForceSegIterator.h"
#include "ContourIterator.h"

/*!
 * \file BruteForceSegIterator4OpenContour.h
 * \brief  definition d'un iterateur naif de segments maximaux 
 * \author Tristan Roussillon
 *
 */

/*!
 * \class BruteForceSegIterator4OpenContour
 * \brief iterateur naif de segments maximaux sur un contour incomplet
 * \author Tristan Roussillon
 *
 */
class BruteForceSegIterator4OpenContour: public BruteForceSegIterator {

private :

ContourIterator end; /*!< fin du contour */


public : 

/*!
 * \brief Constructeur
 * \param pf : fabrique du segment
 * \param pv : ensemble de segments
 * \param pi : iterateur de contour sur le premier point du segment
 * \param pj : iterateur de contour sur le dernier point du segment
 * \param pend : iterateur de contour sur la fin du contour
 */
 BruteForceSegIterator4OpenContour(
				FactorySeg* pf, 
				std::vector<Seg*>* pv, 
				const ContourIterator& pi, 
				const ContourIterator& pj, 
				const ContourIterator& pend);


/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(AbstractSegIterator& t);
/*!
 * \brief operateur de difference
 */ 
	bool operator!=(AbstractSegIterator& t); 

};

      
#endif
