#ifndef ClosedContourIterator_H
#define ClosedContourIterator_H

#include "ContourIterator.h"

/*!
 * \file ClosedContourIterator.h
 * \brief  definition d'un iterateur sur un contour complet
 * \author Tristan Roussillon
 *
 */

/*!
 * \class ClosedContourIterator
 * \brief iterateur sur un contour complet
 * \author Tristan Roussillon
 *
 */
class ClosedContourIterator: public AbstractContourIterator {

private: 

	int ider; /*!< indice du dernier point du contour */

public: 

/*!
 * \brief Constructeur
 * \param c, un contour
 * \param i, l'indice du point courant
 */
 ClosedContourIterator(Contour* cont, int ind);

/*!
 * \brief Destructeur
 */
 ~ClosedContourIterator() {
}

/*!
 * \brief Methode de copie
 */
	AbstractContourIterator* copy();

/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();
/*!
 * \brief Methode permettant
 * de reculer l'iterateur
 */
	void operator--(); 

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(const AbstractContourIterator& t) const;

/*!
 * \brief operateur de difference
 */ 
	bool operator!=(const AbstractContourIterator& t) const; 

};

      
#endif
