#ifndef ContourScan_H
#define ContourScan_H

#include "AbstractContourIterator.h"
#include "ContourIterator.h"
#include "Contour.h"

/*!
 * \file ContourScan.h
 * \brief balayage d'un contour
 * \author Tristan Roussillon
 *
 */

/*!
 * \class ContourScan
 * \brief balayage d'un contour
 * \author Tristan Roussillon
 *
 */
class ContourScan {

private : 
	AbstractContourIterator* firstPoint; /*!< iterateur sur le premier point */
	AbstractContourIterator* lastPoint; /*!< iterateur de fin */

public : 
/*!
 * \brief  constructeur 
 *
 * \param pc : un pointeur vers un contour
 *
 */
	ContourScan(Contour* pc);
/*!
 * \brief  destructeur
 *
 */
	~ContourScan();

/*!
 * \brief  pointeur vers le premier point du contour
 *
 */
	ContourIterator begin() const;
/*!
 * \brief  pointeur vers le dernier point du contour
 *
 */
	ContourIterator end() const;

};

      
#endif
