#ifndef FactoryDSS4_H
#define FactoryDSS4_H

#include "DSS4.h"
#include "FactoryDSS.h"
/*!
 * \file FactoryDSS4.h
 * \brief Definition d'une fabrique a segments de droite 4-connexe
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FactoryDSS4
 * \brief fabrique a segments de droite 4-connexe
 * \author Tristan Roussillon
 * cette classe modelise une fabrique a segments de droite 4-connexe
 * selon le modele de conception de la fabrique abstraite (abstract factory).
 */
class FactoryDSS4 : public FactoryDSS {
public : 
	FactoryDSS4();
/*!
 * \brief Methode 
 * permettant de creer un segment de droite
 * 
 * \param point
 * \param point
 */
	DSS4* createSeg(const Point<int>&, const Point<int>&) const;
/*!
 * \brief Methode 
 * permettant de creer un segment de droite
 * 
 * \param un pointeur vers un segment de droite (DSS)
 */
	DSS4* createSeg(PushPopSeg*) const;
};

#endif


