#ifndef FactoryDSS8_H
#define FactoryDSS8_H

#include "DSS8.h"
#include "FactoryDSS.h"
/*!
 * \file FactoryDSS8.h
 * \brief Definition d'une fabrique a segments de droite 8-connexe
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FactoryDSS8
 * \brief fabrique a segments de droite 8-connexe
 * \author Tristan Roussillon
 * cette classe modelise une fabrique a segments de droite 8-connexe
 * selon le modele de conception de la fabrique abstraite (abstract factory).
 */
class FactoryDSS8 : public FactoryDSS {
public : 
	FactoryDSS8();
/*!
 * \brief Methode
 * permettant de creer un segment de droite
 * 
 * \param point
 * \param point
 */
	DSS8* createSeg(const Point<int>&, const Point<int>&) const;
/*!
 * \brief Methode 
 * permettant de creer un segment de droite
 * 
 * \param un pointeur vers un segment de droite (DSS)
 */
	DSS8* createSeg(PushPopSeg*) const;
};

#endif

