#ifndef FactoryFrontBackSeg_H
#define FactoryFrontBackSeg_H

#include "FrontBackSeg.h"
#include "FactorySeg.h"
/*!
 * \file FactoryFrontBackSeg.h
 * \brief Definition d'une fabrique a segments (classe FrontBackSeg)
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FactoryFrontBackSeg
 * \brief fabrique a segments (classe FrontBackSeg)
 * selon le modele de conception de la fabrique abstraite (abstract factory).
 * \author Tristan Roussillon
 */
class FactoryFrontBackSeg : public FactorySeg {
public : 
/*!
 * \brief Methode virtuelle pure, 
 * permettant de creer un segment
 * 
 * \param point
 * \param point
 */
	virtual FrontBackSeg* createSeg(const Point<int>&, const Point<int>&) const = 0;


	virtual ~FactoryFrontBackSeg() {}
};

#endif


