#ifndef FactoryPushPopSeg_H
#define FactoryPushPopSeg_H

#include "PushPopSeg.h"
#include "FactoryFrontBackSeg.h"
/*!
 * \file FactoryPushPopSeg.h
 * \brief Definition d'une fabrique a segments (classe PushPopSeg)
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FactoryPushPopSeg
 * \brief fabrique a segments (classe PushPopSeg)
 * selon le modele de conception de la fabrique abstraite (abstract factory).
 * \author Tristan Roussillon
 */
class FactoryPushPopSeg : public FactoryFrontBackSeg {
public : 
/*!
 * \brief Methode virtuelle pure, 
 * permettant de creer un segment
 * 
 * \param point
 * \param point
 */
	virtual PushPopSeg* createSeg(const Point<int>&, const Point<int>&) const = 0;

/*!
 * \brief Methode virtuelle pure, 
 * permettant de creer un segment
 * 
 * \param ~ un pointeur vers un segment (PushPopSeg)
 */
	virtual PushPopSeg* createSeg(PushPopSeg*) const = 0;

	virtual ~FactoryPushPopSeg() {}
};

#endif


