#ifndef FactorySeg_H
#define FactorySeg_H

#include "Seg.h"
/*!
 * \file FactorySeg.h
 * \brief Definition d'une fabrique a segments (classe Seg)
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FactorySeg
 * \brief fabrique a segments (classe Seg)
 * selon le modele de conception de la fabrique abstraite (abstract factory).
 * \author Tristan Roussillon
 */
class FactorySeg {
public : 
/*!
 * \brief Methode virtuelle pure, 
 * permettant de creer un segment
 * 
 * \param point
 * \param point
 */
	virtual Seg* createSeg(const Point<int>&, const Point<int>&) const = 0;

	virtual ~FactorySeg() {}
};

#endif


