#ifndef FRACTION_H
#define FRACTION_H

#include <iostream>
#include <cstdlib>

//interface de la classe
class Fraction {
  
friend std::ostream& operator<<(std::ostream&, const Fraction&); //operateur de sortie
  
public : 
       	Fraction(int = 0, int = 1); //constructeur par defaut
       	Fraction(const Fraction&); //constructeur de copie
       	~Fraction(); //destructeur
       	Fraction& operator=(const Fraction&); //operateur d'affectation
       
       	//operateurs de comparaison
       	bool operator<(const Fraction&) const;
       	bool operator>(const Fraction&) const;
       	bool operator<=(const Fraction&) const;
       	bool operator>=(const Fraction&) const;
       	bool operator==(const Fraction&) const;
       	bool operator!=(const Fraction&) const;

       	//operateurs de calcul
      	Fraction operator*(const Fraction&) const;
       	Fraction inv() const; //renvoie l'inverse d'une fraction
	      Fraction abs() const; //renvoie la valeur absolue d'une fraction
       	Fraction operator/(const Fraction&) const;
       	Fraction operator+(const Fraction&) const;
       	Fraction operator-(const Fraction&) const;
				Fraction operator-() const;

				//pgcd
				int pgcd();
				//reduit
				void reduire();       	
				//renvoi un reel
       	double reel() const;
				//renvoi un booleen indiquant si
				// la fraction est definie
				// (denominateur different de 0)
				bool estDef() const;

       	//accesseurs
       	int num() const;
       	int den() const;
       
       	std::string toString() const;

private : 
        int _num, _den;         

				//pgcd
				int pgcd(int a, int b);
};
      
	class DivisionByZero : public std::exception {};

#endif

