#ifndef FrontBackSeg_H
#define FrontBackSeg_H

#include "Seg.h"
/*!
 * \file FrontBackSeg.h
 * \brief Definition d'une classe modelisant un segment d'une courbe discrete
 * qu'on peut etendre aussi bien a l'avant (dans le sens de parcours) qu'a l'arriere
 * \author Tristan Roussillon
 *
 */


/*!
 * \class FrontBackSeg
 * \brief Segment (portion) d'une courbe discrete 
 * qu'on peut etendre aussi bien a l'avant 
 * (dans le sens de parcours) qu'a l'arriere
 * \author Tristan Roussillon
 */
class FrontBackSeg : public Seg {

public :
/*!
 * \brief Methode virtuelle pure, 
 * permettant d'ajouter un point 
 * a l'arriere du segment 
 * (dans le sens de parcours de la courbe)
 * 
 * \param p : point
 *
 */
	virtual bool push_back(const Point<int>& ) = 0;


	virtual ~FrontBackSeg() {}
};

#endif
