#ifndef GreedySegmentation_H
#define GreedySegmentation_H

#include "AbstractSegIterator.h"
#include "SegIterator.h"
#include "Contour.h"
#include "ContourIterator.h"
#include "ContourScan.h"
#include "FactorySeg.h"

/*!
 * \file GreedySegmentation.h
 * \brief decomposition gloutonne en segments
 * \author Tristan Roussillon
 *
 */

/*!
 * \class GreedySegmentation
 * \brief decomposition gloutonne
 * \author Tristan Roussillon
 *
 */
class GreedySegmentation {

private : 
	std::vector<Seg*> vSegs; /*!< ensemble des segments extraits au cours des iterations*/
	std::vector<Seg*> vTmp; /*!< ensemble des segments temporaires */
	AbstractSegIterator* firstSeg; /*!< premier segment du contour */
	AbstractSegIterator* lastSeg; /*!< dernier segment du contour */

public : 
/*!
 * \brief  constructeur 
 *
 * \param pc : un pointeur vers un contour
 *
 */
	GreedySegmentation(Contour* pc, FactorySeg* pf);
/*!
 * \brief  destructeur
 *
 */
	~GreedySegmentation();

/*!
 * \brief  pointeur vers le premier point du contour
 *
 */
	SegIterator begin() const;
/*!
 * \brief  pointeur vers le dernier point du contour
 *
 */
	SegIterator end() const;

};

      
#endif
