#ifndef OpenContourIterator_H
#define OpenContourIterator_H

#include "ContourIterator.h"

/*!
 * \file OpenContourIterator.h
 * \brief  definition d'un iterateur sur un contour incomplet
 * \author Tristan Roussillon
 *
 */

/*!
 * \class OpenContourIterator
 * \brief iterateur sur un contour incomplet
 * \author Tristan Roussillon
 *
 */
class OpenContourIterator: public AbstractContourIterator {

public : 

/*!
 * \brief Constructeur
 * \param c, un contour
 * \param i, l'indice du point courant
 */
 OpenContourIterator(Contour* cont, int ind);

/*!
 * \brief Destructeur
 */
	~OpenContourIterator() {}
/*!
 * \brief Methode de copie
 */
	AbstractContourIterator* copy();

/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();
/*!
 * \brief Methode permettant
 * de reculer l'iterateur
 */
	void operator--();

};

      
#endif
