#ifndef PushPopSeg_H
#define PushPopSeg_H

#include "FrontBackSeg.h"
/*!
 * \file PushPopSeg.h
 * \brief Definition d'une classe modelisant un segment d'une courbe discrete
 * qu'on peut etendre aussi bien a l'avant (dans le sens de parcours) qu'a l'arriere
 * \author Tristan Roussillon
 *
 */


/*!
 * \class PushPopSeg
 * \brief Segment (portion) d'une courbe discrete 
 * qu'on peut etendre aussi bien a l'avant 
 * (dans le sens de parcours) qu'a l'arriere
 * \author Tristan Roussillon
 */
class PushPopSeg : public FrontBackSeg {

public :
/*!
 * \brief Methode virtuelle pure, 
 * permettant de supprimer un point 
 * a l'arriere du segment 
 * (dans le sens de parcours de la courbe)
 * 
 * \param p : point
 *
 */
	virtual bool pop_back(const Point<int>& ) = 0;


	virtual ~PushPopSeg() {}
};

#endif
