#ifndef PushPopSegIterator4ClosedContour_H
#define PushPopSegIterator4ClosedContour_H

#include "PushPopSegIterator.h"
#include "ContourIterator.h"

/*!
 * \file PushPopSegIterator4ClosedContour.h
 * \brief  definition d'un iterateur de segments maximaux 
 * par ajout a l'avant et retrait par l'arriere sur un contour complet
 * \author Tristan Roussillon
 *
 */

/*!
 * \class PushPopSegIterator4ClosedContour
 * \brief iterateur de segments maximaux 
 * par ajout a l'avant et retrait par l'arriere sur un contour complet
 * \author Tristan Roussillon
 *
 */
class PushPopSegIterator4ClosedContour: public PushPopSegIterator {

private : 

int n; /*!< nombre d'iterations */

public : 

/*!
 * \brief Constructeur
 * \param pf : fabrique du segment
 * \param pv : ensemble de segments
 * \param pi : iterateur de contour sur le premier point du segment
 * \param pj : iterateur de contour sur le dernier point du segment
 */
 PushPopSegIterator4ClosedContour(
				FactoryPushPopSeg* pf, 
				std::vector<PushPopSeg*>* pv, 
				const ContourIterator& pi, 
				const ContourIterator& pj);


/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(AbstractSegIterator& t);
/*!
 * \brief operateur de difference
 */ 
	bool operator!=(AbstractSegIterator& t); 

};

      
#endif
