#ifndef PushPopSegIterator4OpenContour_H
#define PushPopSegIterator4OpenContour_H

#include "PushPopSegIterator.h"
#include "ContourIterator.h"

/*!
 * \file PushPopSegIterator4OpenContour.h
 * \brief  definition d'un iterateur de segments maximaux
 * par ajout a l'avant et retrait par l'arriere sur un contour incomplet
 * \author Tristan Roussillon
 *
 */

/*!
 * \class PushPopSegIterator4OpenContour
 * \brief iterateur de segments maximaux 
 * par ajout a l'avant et retrait par l'arriere sur un contour incomplet
 * \author Tristan Roussillon
 *
 */
class PushPopSegIterator4OpenContour: public PushPopSegIterator {

private :

ContourIterator end; /*!< fin du contour */


public : 

/*!
 * \brief Constructeur
 * \param pf : fabrique du segment
 * \param pv : ensemble de segments
 * \param pi : iterateur de contour sur le premier point du segment
 * \param pj : iterateur de contour sur le dernier point du segment
 * \param pend : iterateur de contour sur la fin du contour
 */
 PushPopSegIterator4OpenContour(
				FactoryPushPopSeg* pf, 
				std::vector<PushPopSeg*>* pv, 
				const ContourIterator& pi, 
				const ContourIterator& pj, 
				const ContourIterator& pend);


/*!
 * \brief Methode permettant
 * d'avancer l'iterateur
 */
	void operator++();

/*!
 * \brief operateur d'egalite
 */ 
	bool operator==(AbstractSegIterator& t);
/*!
 * \brief operateur de difference
 */ 
	bool operator!=(AbstractSegIterator& t); 

};

      
#endif
