#include "../inc/UIfig.h"

#include "../inc/Contour.h"
#include "../inc/FP.h"

#include <string>
#include <sstream>

/*!
 * \file testFP.cpp
 * \brief Programme qui lit a l'entree standard le code d'un contour,
 * qui calcule le Faithful Polygone de ce code,
 * puis qui cree le graphique resultat "FP.svg"
 *
 * \author Tristan Roussillon
 *
 */



int main(int argc, char *argv[]) {

	std::string curve, codeFreeman, ptx, pty;

	//lecture de la courbe
	std::cin >> curve;
	Contour *c = new Contour(curve);

	//dessin du contour
	UIfig *fig;
	fig = new UIfig("FP.svg", c->getPts());

	//dessin du polygone
	FP *polygon = new FP(c);
	fig->addPolyline(polygon->getFP(), "faithful polygon", "red");

	//dessin du contour retrouve a partir du polygone
	//fig->addPolyline(polygon->getContour().getPts(), "retrieved contour", "blue");

	//fin
	delete(polygon);
	delete(fig);
	delete(c);

}
