#include "../inc/UIfig.h"

#include "../inc/Contour.h"
#include "../inc/FP.h"

#include <string>
#include <sstream>

/*!
 * \file testMLP.cpp
 * \brief Programme qui lit a l'entree standard le code
 * de Freeman d'une courbe discrete 4-connexe,
 * qui calcule le MLP de cette courbe discrete,
 * puis qui cree le graphique resultat "MLP.svg"
 *
 * \author Tristan Roussillon
 *
 */



int main(int argc, char *argv[]) {

	std::string curve, codeFreeman, ptx, pty;

	//lecture de la courbe
	std::cin >> curve;
	Contour *c = new Contour(curve);

	//dessin du contour
	UIfig *fig;
	fig = new UIfig("MLP.svg", c->getPts());
	fig->addPixels(c->getPts(), "pixels", "blue");

	//dessin du polygone
	FP *polygon = new FP(c);
	fig->addPolyline(polygon->getMLP(), "MLP","red");

	//fin
	delete(polygon);
	delete(fig);
	delete(c);

}
