#include "../inc/BackFrontSegIterator4ClosedContour.h"

BackFrontSegIterator4ClosedContour::BackFrontSegIterator4ClosedContour(
	FactoryFrontBackSeg* pf, 
	std::vector<FrontBackSeg*>* pv, 
	const ContourIterator& pi, 
	const ContourIterator& pj) : BackFrontSegIterator(pf,pv,pi,pj) {

	this->n = 0;

}

void BackFrontSegIterator4ClosedContour::operator++() {

	this->n++;

	if (*i != *j) {
	//si le dernier segment ne recouvre pas tout le contour

		//repositionnement des pointeurs
		i = j; --i;
		//creation d'un nouveau segment
		v->push_back( fseg->createSeg(*i, *j) ); 
		//croissance vers l'arriere	
		do {
			--i;
		} while (v->back()->push_back(*i));
		++i;
		//croissance vers l'avant
		do {
			++j;
		} while (v->back()->push_front(*j));

	}

}

bool BackFrontSegIterator4ClosedContour::operator==(AbstractSegIterator& t) {
	return ( (this->n > 1) && (*(t.getSeg()) == *(this->getSeg())) );
}

bool BackFrontSegIterator4ClosedContour::operator!=(AbstractSegIterator& t) {
	return ( (this->n == 0) || (*(t.getSeg()) != *(this->getSeg())) );	
} 

