#include "../inc/BackFrontSegIterator4OpenContour.h"

BackFrontSegIterator4OpenContour::BackFrontSegIterator4OpenContour(
	FactoryFrontBackSeg* pf, 
	std::vector<FrontBackSeg*>* pv, 
	const ContourIterator& pi, 
	const ContourIterator& pj, 
	const ContourIterator& pend) : BackFrontSegIterator(pf,pv,pi,pj), end(pend) {}

void BackFrontSegIterator4OpenContour::operator++() {

	if (j != end) { //si j'ai pas termine

		//repositionnement des pointeurs
		i = j; --i;
		//creation d'un nouveau segment
		v->push_back( fseg->createSeg(*i, *j) ); 
		//croissance vers l'arriere	
		do {
			--i;
		} while (v->back()->push_back(*i));
		++i;
		//croissance vers l'avant tant que c'est possible
		do {
			++j;
		} while ( (j != end) && (v->back()->push_front(*j)) );

	} else { //si je suis a la fin
		
		v->push_back(0); //mon segment est mis a null

	}

}

bool BackFrontSegIterator4OpenContour::operator==(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return true;
		else return false;
	} else  {
		if (t.getSeg() == 0) return false;
		else return (*(t.getSeg()) == *(this->getSeg()));
	}	
}

bool BackFrontSegIterator4OpenContour::operator!=(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return false;
		else return true;
	} else  {
		if (t.getSeg() == 0) return true;
		else return (*(t.getSeg()) != *(this->getSeg()));
	}	
} 

