#include "../inc/BruteForceSegIterator4ClosedContour.h"

BruteForceSegIterator4ClosedContour::BruteForceSegIterator4ClosedContour(
	FactorySeg* pf, 
	std::vector<Seg*>* pv, 
	const ContourIterator& pi, 
	const ContourIterator& pj) : BruteForceSegIterator(pf,pv,pi,pj) {

	this->n = 0;

}

void BruteForceSegIterator4ClosedContour::operator++() {

	this->n++;

	if (*i != *j) {
	//si le dernier segment ne recouvre pas tout le contour

		//indice du dernier segment max
		int ilast = v->size()-1;
		do {
			//repositionnement des pointeurs
			++i; j = i; ++j;
			//creation d'un nouveau segment
			v->push_back( fseg->createSeg(*i, *j) ); ++j;
			//croissance du segment 
			while (v->back()->push_front(*j)) ++j;
			//comparaison avec le dernier segment max
		} while (v->back()->getLast() == v->at(ilast)->getLast());

	}

}

bool BruteForceSegIterator4ClosedContour::operator==(AbstractSegIterator& t) {
	return ( (this->n > 1) && (*(t.getSeg()) == *(this->getSeg())) );
}

bool BruteForceSegIterator4ClosedContour::operator!=(AbstractSegIterator& t) {
	return ( (this->n == 0) || (*(t.getSeg()) != *(this->getSeg())) );	
} 

