#include "../inc/BruteForceSegIterator4OpenContour.h"

BruteForceSegIterator4OpenContour::BruteForceSegIterator4OpenContour(
	FactorySeg* pf, 
	std::vector<Seg*>* pv, 
	const ContourIterator& pi, 
	const ContourIterator& pj, 
	const ContourIterator& pend) : BruteForceSegIterator(pf,pv,pi,pj), end(pend) {}

void BruteForceSegIterator4OpenContour::operator++() {

	if (j != end) { //si j'ai pas termine

		//indice du dernier segment max
		int ilast = v->size()-1;
		do {
			//repositionnement des pointeurs
			++i; j = i; ++j;
			//creation d'un nouveau segment
			v->push_back( fseg->createSeg(*i, *j) ); ++j;
			//croissance du segment tant que c'est possible
			while ( (j != end) && (v->back()->push_front(*j)) ) ++j;
			//comparaison avec le dernier segment max
		} while ( (j != end) && (v->back()->getLast() == v->at(ilast)->getLast()) );

	} else { //si je suis a la fin
		
		v->push_back(0); //mon segment est mis a null

	}

}

bool BruteForceSegIterator4OpenContour::operator==(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return true;
		else return false;
	} else  {
		if (t.getSeg() == 0) return false;
		else return (*(t.getSeg()) == *(this->getSeg()));
	}	
}

bool BruteForceSegIterator4OpenContour::operator!=(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return false;
		else return true;
	} else  {
		if (t.getSeg() == 0) return true;
		else return (*(t.getSeg()) != *(this->getSeg()));
	}	
} 

