#include "../inc/Contour.h"

Contour::Contour(std::string s) {

	std::string codeFreeman, ptx, pty;

	//recuperation du code
	std::istringstream iss(s);
	std::getline(iss, codeFreeman, ';' );

	//recuperation du point
	std::getline(iss, ptx, ';' );
	std::getline(iss, pty, ';' );

	int x, y;
	std::istringstream is(ptx);
	is >> x;
	std::istringstream is2(pty);
	is2 >> y;

	Point<int> pDeb(x,y);

	//construction
	*this = Contour(pDeb, codeFreeman);
}

Contour::Contour(Point<int> pt, std::string code) {

	//dernier point traite
	Point<int> der = pt;
	this->vPts.push_back(der);

	int n = code.length();
	for (int i = 0; i < n; i++) {

		//calcul et stockage de chaque point
		der = der + this->letter2Vec(code.at(i));	
		this->vPts.push_back(der);

	}

	//ouverture ou fermeture du contour
	this->open = ( this->vPts.at(0) != this->vPts.at(this->vPts.size()-1) );
}

Contour::Contour(std::vector<Point<int> > v) {
	this->vPts = v;
	//ouverture ou fermeture du contour
	this->open = ( this->vPts.at(0) != this->vPts.at(this->vPts.size()-1) );
}

bool Contour::isOpen() const {
	return this->open;
}

Point<int> Contour::at(int i) const {
	return this->vPts.at(i);
}

std::vector<Point<int> > Contour::getPts() const {
	return this->vPts;
}

int Contour::getLength() const {
	return this->vPts.size();
}

Vecteur<int> Contour::letter2Vec(const char& letter) {
	if (letter == '0') return Vecteur<int>(1,0);
	else if (letter == '1') return Vecteur<int>(0,1);
	else if (letter == '2') return Vecteur<int>(-1,0);
	else if (letter == '3') return Vecteur<int>(0,-1);
	else throw BadConnectivity();
}

