#include "../inc/ContourScan.h"
#include "../inc/OpenContourIterator.h"
#include "../inc/ClosedContourIterator.h"

ContourScan::ContourScan(Contour* pc) {

	if (pc->isOpen()) { //si le contour est incomplet
		this->firstPoint = new OpenContourIterator(pc,0); 
		this->lastPoint = new OpenContourIterator(pc,pc->getLength()); 
	} else { // si le contour est complet
		this->firstPoint = new ClosedContourIterator(pc,0); 
		this->lastPoint = new ClosedContourIterator(pc,pc->getLength()-1); 
	}
}

ContourScan::~ContourScan() {
	delete(this->firstPoint);
	delete(this->lastPoint);
}

ContourIterator ContourScan::begin() const {
	return ContourIterator(this->firstPoint->copy());
}

ContourIterator ContourScan::end() const {
	return ContourIterator(this->lastPoint->copy());
}
