#include "../inc/DSS4.h"

//constructeur 
DSS4::DSS4(const Point<int>& P1, const Point<int>& P2) : DSS(P1,P2) {}


int DSS4::getOmega() const {
	return (std::abs(this->a)+std::abs(this->b));
}

bool DSS4::areNeighbors(const Point<int>& P, const Point<int>& Q) const {
	return ((std::abs(P.x-Q.x) + std::abs(P.y-Q.y))==1);
}
bool DSS4::isBadConnected(const Point<int>& pfirst, const Point<int>& plast, const Point<int>& N) const {
	if (!areNeighbors(plast,N)) {
 		throw BadConnectivity();
	}

	Vecteur<int> v = N - plast;//depend de pfirst et plast
	if (plast.y > pfirst.y) 
		if (v == Vecteur<int>(0, -1)) return true;
	if (plast.y < pfirst.y)
		if (v == Vecteur<int>(0, 1)) return true;
	if (plast.x > pfirst.x)
		if (v == Vecteur<int>(-1, 0)) return true;
	if (plast.x < pfirst.x)
		if (v == Vecteur<int>(1, 0)) return true;

	return false;
}
/******************************/
Point<int> DSS4::nextPt(const Point<int>& pfirst, const Point<int>& plast) const {
	Point<int> Q = pfirst;
	int dx = (plast.x - pfirst.x);
	int dy = (plast.y - pfirst.y);
	if (std::abs(this->b) >= std::abs(this->a)) {
		if (dx > 0) Q.x++;
		if (dx < 0) Q.x--;
		int r = this->a*Q.x-this->b*Q.y;
		if (((r-c1)>=0)&&((r-c2)<=0)) return Q;
		else {
			if (dx > 0) Q.x--;
			if (dx < 0) Q.x++;
			if (dy > 0) Q.y++;
			if (dy < 0) Q.y--;
			return Q;
		}
	} else {
		if (dy > 0) Q.y++;
		if (dy < 0) Q.y--;
		int r = this->a*Q.x-this->b*Q.y;
		if (((r-c1)>=0)&&((r-c2)<=0)) return Q;
		else {
			if (dy > 0) Q.y--;
			if (dy < 0) Q.y++;
			if (dx > 0) Q.x++;
			if (dx < 0) Q.x--;
			return Q;
		}
	}
}

/******************************/
Vecteur<int> DSS4::shift() const {
	Vecteur<int> v;

	if (this->a >= 0) {
		if (this->b >= 0) v = Vecteur<int>(-1, 1);
		else v = Vecteur<int>(-1, -1);
	} else {
		if (this->b >= 0) v = Vecteur<int>(1, 1);
		else v = Vecteur<int>(1, -1);
	}

	return v;
}

