#include "../inc/GreedySegIterator.h"

GreedySegIterator::GreedySegIterator(FactorySeg* pf, 
									std::vector<Seg*>* pv, 
									const ContourIterator& pi, 
									const ContourIterator& pj, 
									const ContourIterator& pend) : fseg(pf),v(pv),end(pend), AbstractSegIterator(pi,pj) {}

GreedySegIterator::~GreedySegIterator() {}


Seg* GreedySegIterator::operator*() {
	return this->v->back();
}

Seg* GreedySegIterator::getSeg() {
	return this->v->back();
}

void GreedySegIterator::operator++() {

	if (j != end) { //si j'ai pas termine

		//repositionnement des iterateurs
		i = j; --i;

		//je cree un nouveau segment
		v->push_back( fseg->createSeg(*i, *j) );
		//std::cout << "seg " << v->back() << std::endl;
		++j;
		 //j'ajoute des points a l'avant tant que je peux	
		while ( (j != end) && (v->back()->push_front(*j)) ) {
			++j;
		}
		//std::cout << "seg " << v->back()->toString() << std::endl;

	} else { //si je suis a la fin
		
		v->push_back(0); //mon segment est mis a null

	}
}

bool GreedySegIterator::operator==(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return true;
		else return false;
	} else  {
		if (t.getSeg() == 0) return false;
		else return (*(t.getSeg()) == *(this->getSeg()));
	}	
}

bool GreedySegIterator::operator!=(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return false;
		else return true;
	} else  {
		if (t.getSeg() == 0) return true;
		else return (*(t.getSeg()) != *(this->getSeg()));
	}	
} 



