#include "../inc/GreedySegmentation.h"
#include "../inc/GreedySegIterator.h"

GreedySegmentation::GreedySegmentation(Contour* pc, FactorySeg* pf) {

	//iterateur de debut et fin du contour
	ContourScan* scan = new ContourScan(pc);
	ContourIterator i = scan->begin();
	ContourIterator end = scan->end();
	delete(scan);

	//iterateur de debut et fin du segment
	ContourIterator j = i;
	if (i != end) ++j;
	else throw BadConnectivity();	//un contour a forcement au moins deux points

	//calcul du premier segment
	vSegs.push_back( pf->createSeg(*i, *j) );	++j;
	while ( (j != end) && (vSegs.back()->push_front(*j)) ) ++j;
	this->firstSeg = new GreedySegIterator(pf,&vSegs,i,j,end);

	//init fin iterateur de segment 
	vTmp.push_back(0);
	this->lastSeg = new GreedySegIterator(pf,&vTmp,i,j,end); 
}

GreedySegmentation::~GreedySegmentation() {
	delete(this->firstSeg);
	delete(this->lastSeg);
	for (int i = 0; i < vSegs.size(); i++) {
		delete(vSegs.at(i));
	}
}

SegIterator GreedySegmentation::begin() const {
	return SegIterator(this->firstSeg);
}

SegIterator GreedySegmentation::end() const {
	return SegIterator(this->lastSeg);
}
