#include "../inc/PushPopSegIterator4OpenContour.h"

PushPopSegIterator4OpenContour::PushPopSegIterator4OpenContour(
	FactoryPushPopSeg* pf, 
	std::vector<PushPopSeg*>* pv, 
	const ContourIterator& pi, 
	const ContourIterator& pj, 
	const ContourIterator& pend) : PushPopSegIterator(pf,pv,pi,pj), end(pend) {}

void PushPopSegIterator4OpenContour::operator++() {

	if (j != end) { //si j'ai pas termine

		//creation d'un nouveau segment
		v->push_back(fseg->createSeg(v->back()));//clonage
		//suppression a l'arriere
		//tant que je ne peux pas ajouter a l'avant
		do {
			v->back()->pop_back(*i);
			++i;
		} while (!(v->back()->push_front(*j)));
		//croissance vers l'avant tant que c'est possible
		do {
			++j;
		} while ( (j != end) && (v->back()->push_front(*j)) );

	} else { //si je suis a la fin
		
		v->push_back(0); //mon segment est mis a null

	}

}

bool PushPopSegIterator4OpenContour::operator==(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return true;
		else return false;
	} else  {
		if (t.getSeg() == 0) return false;
		else return (*(t.getSeg()) == *(this->getSeg()));
	}	
}

bool PushPopSegIterator4OpenContour::operator!=(AbstractSegIterator& t) {
	if (this->getSeg() == 0) {
		if (t.getSeg() == 0) return false;
		else return true;
	} else  {
		if (t.getSeg() == 0) return true;
		else return (*(t.getSeg()) != *(this->getSeg()));
	}	
} 

